Diff for /loncom/lonsql between versions 1.60 and 1.69

version 1.60, 2004/05/11 21:08:20 version 1.69, 2005/11/24 20:03:49
Line 115  use Fcntl; Line 115  use Fcntl;
 use Tie::RefHash;  use Tie::RefHash;
 use DBI;  use DBI;
 use File::Find;  use File::Find;
   use localenroll;
   
 ########################################################  ########################################################
 ########################################################  ########################################################
Line 205  my $run =0;              # running count Line 206  my $run =0;              # running count
 my $perlvarref=LONCAPA::Configuration::read_conf('loncapa.conf');  my $perlvarref=LONCAPA::Configuration::read_conf('loncapa.conf');
 my %perlvar=%{$perlvarref};  my %perlvar=%{$perlvarref};
 #  #
   # Write the /home/www/.my.cnf file 
   my $conf_file = '/home/www/.my.cnf';
   if (! -e $conf_file) {
       if (open MYCNF, ">$conf_file") {
           print MYCNF <<"ENDMYCNF";
   [client]
   user=www
   password=$perlvar{'lonSqlAccess'}
   ENDMYCNF
           close MYCNF;
       } else {
           warn "Unable to write $conf_file, continuing";
       }
   }
   
   
   #
 # Make sure that database can be accessed  # Make sure that database can be accessed
 #  #
 my $dbh;  my $dbh;
Line 223  unless ($dbh = DBI->connect("DBI:mysql:l Line 241  unless ($dbh = DBI->connect("DBI:mysql:l
   
     exit 1;      exit 1;
 } else {  } else {
       unlink('/home/httpd/html/lon-status/mysql.txt');
     $dbh->disconnect;      $dbh->disconnect;
 }  }
   
Line 240  if (-e $pidfile) { Line 259  if (-e $pidfile) {
 #  #
 # Read hosts file  # Read hosts file
 #  #
 my %hostip;  
 my $thisserver;  my $thisserver;
 my $PREFORK=4; # number of children to maintain, at least four spare  my $PREFORK=4; # number of children to maintain, at least four spare
 open (CONFIG,"$perlvar{'lonTabDir'}/hosts.tab") || die "Can't read host file";  open (CONFIG,"$perlvar{'lonTabDir'}/hosts.tab") || die "Can't read host file";
 while (my $configline=<CONFIG>) {  while (my $configline=<CONFIG>) {
     my ($id,$domain,$role,$name,$ip)=split(/:/,$configline);      my ($id,$domain,$role,$name)=split(/:/,$configline);
     chomp($ip);      $name=~s/\s//g;
     $hostip{$ip}=$id;  
     $thisserver=$name if ($id eq $perlvar{'lonHostID'});      $thisserver=$name if ($id eq $perlvar{'lonHostID'});
     $PREFORK++;      #$PREFORK++;
 }  }
 close(CONFIG);  close(CONFIG);
 #  #
 $PREFORK=int($PREFORK/4);  #$PREFORK=int($PREFORK/4);
   
 #  #
 # Create a socket to talk to lond  # Create a socket to talk to lond
Line 381  sub make_new_child { Line 398  sub make_new_child {
     $queryid .= $run;      $queryid .= $run;
     print $client "$queryid\n";      print $client "$queryid\n";
     #      #
     &logthis("QUERY: $query - $arg1 - $arg2 - $arg3");      # &logthis("QUERY: $query - $arg1 - $arg2 - $arg3");
     sleep 1;      sleep 1;
             #              #
             my $result='';              my $result='';
Line 406  sub make_new_child { Line 423  sub make_new_child {
                     $result='no_such_file';                      $result='no_such_file';
                 }                  }
                 # end of log query                  # end of log query
               } elsif ($query eq 'fetchenrollment') {
                   # retrieve institutional class lists
                   my $dom = &unescape($arg1);
                   my %affiliates = ();
                   my %replies = ();
                   my $locresult = '';
                   my $querystr = &unescape($arg3);
                   foreach (split/%%/,$querystr) {
                       if (/^([^=]+)=([^=]+)$/) {
                           @{$affiliates{$1}} = split/,/,$2;
                       }
                   }
                   $locresult = &localenroll::fetch_enrollment($dom,\%affiliates,\%replies);
                   $result = &escape($locresult.':');
                   if ($locresult) {
                       $result .= &escape(join(':',map{$_.'='.$replies{$_}} keys %replies));
                   }
               } elsif ($query eq 'prepare activity log') {
                   my ($cid,$domain) = map {&unescape($_);} ($arg1,$arg2);
                   &logthis('preparing activity log tables for '.$cid);
                   my $command = 
                       qq{$perlvar{'lonDaemons'}/parse_activity_log.pl -course=$cid -domain=$domain};
                   system($command);
                   &logthis($command);
                   my $returnvalue = $?>>8;
                   if ($returnvalue) {
                       $result = 'error: parse_activity_log.pl returned '.
                           $returnvalue;
                   } else {
                       $result = 'success';
                   }
             } else {              } else {
                 # Do an sql query                  # Do an sql query
                 $result = &do_sql_query($query,$arg1,$arg2);                  $result = &do_sql_query($query,$arg1,$arg2);
Line 460  sub process_file { Line 508  sub process_file {
   
 sub do_sql_query {  sub do_sql_query {
     my ($query,$custom,$customshow) = @_;      my ($query,$custom,$customshow) = @_;
   #    &logthis('doing query '.$query);
     $custom     = &unescape($custom);      $custom     = &unescape($custom);
     $customshow = &unescape($customshow);      $customshow = &unescape($customshow);
     #      #

Removed from v.1.60  
changed lines
  Added in v.1.69


FreeBSD-CVSweb <freebsd-cvsweb@FreeBSD.org>